package cn.iocoder.yudao.module.mes.service.machine;

import cn.hutool.core.collection.CollUtil;
import cn.iocoder.yudao.framework.common.util.collection.CollectionUtils;
import cn.iocoder.yudao.module.mes.controller.admin.machine.vo.MachineComponentListReqVO;
import cn.iocoder.yudao.module.mes.controller.admin.machine.vo.MachineComponentSaveReqVO;
import cn.iocoder.yudao.module.mes.dal.dataobject.machine.MachineComponentDO;

import javax.validation.Valid;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 机台 Service 接口
 *
 * @author 内蒙必硕
 */
public interface MachineComponentService {

    /**
     * 创建机台
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createMachineComponent(@Valid MachineComponentSaveReqVO createReqVO);

    /**
     * 更新机台
     *
     * @param updateReqVO 更新信息
     */
    void updateMachineComponent(@Valid MachineComponentSaveReqVO updateReqVO);

    /**
     * 删除机台
     *
     * @param id 编号
     */
    void deleteMachineComponent(Long id);

    /**
     * 获得机台
     *
     * @param id 编号
     * @return 机台
     */
    MachineComponentDO getMachineComponent(Long id);

    /**
     * 获得机台列表
     *
     * @param listReqVO 查询条件
     * @return 机台列表
     */
    List<MachineComponentDO> getMachineComponentList(MachineComponentListReqVO listReqVO);

    List<MachineComponentDO> getList(Collection<Long> ids);
    default Map<Long, MachineComponentDO> getMap(Collection<Long> ids) {
        if (CollUtil.isEmpty(ids)) {
            return new HashMap<>();
        }
        return CollectionUtils.convertMap(getList(ids), MachineComponentDO::getId);
    }
}